---
title: PerformanceTiming
slug: Web/API/PerformanceTiming
tags:
  - API
  - Backwards compatibilty
  - Deprecated
  - Interface
  - Navigation Timing
  - Navigation Timing API
  - Optimization
  - Performance
  - Reference
  - Timing
  - legacy
---
<div>{{APIRef("Navigation Timing")}}</div>

<div class="warning">
<p>This interface is deprecated in the <a href="https://w3c.github.io/navigation-timing/#obsolete">Navigation Timing Level 2 specification</a>. Please use the {{domxref("PerformanceNavigationTiming")}} interface instead.</p>
</div>

<p>The <strong><code>PerformanceTiming</code></strong> interface is a legacy interface kept for backwards compatibility and contains properties that offer performance timing information for various events which occur during the loading and use of the current page. You get a <code>PerformanceTiming</code> object describing your page using the {{domxref("Performance.timing", "window.performance.timing")}} property.</p>

<h2 id="Properties">Properties</h2>

<p><em>The <code>PerformanceTiming</code> interface doesn't inherit any properties.</em></p>

<p>These properties each describe the time at which a particular point in the page loading process was reached. Some correspond to DOM events; others describe the time at which internal browser operations of interest took place.</p>

<p>Each time is provided as an <code>unsigned long long</code> representing the moment, in milliseconds since the UNIX epoch</p>

<p>These properties are listed in the order in which they occur during the navigation process.</p>

<dl>
 <dt>{{deprecated_inline}} {{domxref("PerformanceTiming.navigationStart")}} {{readonlyInline}}</dt>
 <dd>When the prompt for unload terminates on the previous document in the same browsing context. If there is no previous document, this value will be the same as <code>PerformanceTiming.fetchStart</code>.</dd>
 <dt>{{deprecated_inline}} {{domxref("PerformanceTiming.unloadEventStart")}} {{readonlyInline}}</dt>
 <dd>When the {{event("unload")}} event has been thrown, indicating the time at which the previous document in the window began to unload. If there is no previous document, or if the previous document or one of the needed redirects is not of the same origin, the value returned is <code>0</code>.</dd>
 <dt>{{deprecated_inline}}  {{domxref("PerformanceTiming.unloadEventEnd")}} {{readonlyInline}}</dt>
 <dd>When the {{event("unload")}} event handler finishes. If there is no previous document, or if the previous document, or one of the needed redirects, is not of the same origin, the value returned is <code>0</code>.</dd>
 <dt>{{deprecated_inline}}  {{domxref("PerformanceTiming.redirectStart")}} {{readonlyInline}}</dt>
 <dd>When the first HTTP redirect starts. If there is no redirect, or if one of the redirects is not of the same origin, the value returned is <code>0</code>.</dd>
 <dt>{{deprecated_inline}}  {{domxref("PerformanceTiming.redirectEnd")}} {{readonlyInline}}</dt>
 <dd>When the last HTTP redirect is completed, that is when the last byte of the HTTP response has been received. If there is no redirect, or if one of the redirects is not of the same origin, the value returned is <code>0</code>.</dd>
 <dt>{{deprecated_inline}}  {{domxref("PerformanceTiming.fetchStart")}} {{readonlyInline}}</dt>
 <dd>When the browser is ready to fetch the document using an HTTP request. This moment is <em>before</em> the check to any application cache.</dd>
 <dt>{{deprecated_inline}}  {{domxref("PerformanceTiming.domainLookupStart")}} {{readonlyInline}}</dt>
 <dd>When the domain lookup starts. If a persistent connection is used, or the information is stored in a cache or a local resource, the value will be the same as <code>PerformanceTiming.fetchStart</code>.</dd>
 <dt>{{deprecated_inline}}  {{domxref("PerformanceTiming.domainLookupEnd")}} {{readonlyInline}}</dt>
 <dd>When the domain lookup is finished. If a persistent connection is used, or the information is stored in a cache or a local resource, the value will be the same as <code>PerformanceTiming.fetchStart</code>.</dd>
 <dt>{{deprecated_inline}}  {{domxref("PerformanceTiming.connectStart")}} {{readonlyInline}}</dt>
 <dd>When the request to open a connection is sent to the network. If the transport layer reports an error and the connection establishment is started again, the last connection establishment start time is given. If a persistent connection is used, the value will be the same as <code>PerformanceTiming.fetchStart</code>.</dd>
 <dt>{{deprecated_inline}}  {{domxref("PerformanceTiming.connectEnd")}} {{readonlyInline}}</dt>
 <dd>When the connection is opened network. If the transport layer reports an error and the connection establishment is started again, the last connection establishment end time is given. If a persistent connection is used, the value will be the same as <code>PerformanceTiming.fetchStart</code>. A connection is considered as opened when all secure connection handshake, or SOCKS authentication, is terminated.</dd>
 <dt>{{deprecated_inline}}  {{domxref("PerformanceTiming.secureConnectionStart")}} {{readonlyInline}}</dt>
 <dd>When the secure connection handshake starts. If no such connection is requested, it returns <code>0</code>.</dd>
 <dt>{{deprecated_inline}}  {{domxref("PerformanceTiming.requestStart")}} {{readonlyInline}}</dt>
 <dd>When the browser sent the request to obtain the actual document, from the server or from a cache. If the transport layer fails after the start of the request and the connection is reopened, this property will be set to the time corresponding to the new request.</dd>
 <dt>{{deprecated_inline}}  {{domxref("PerformanceTiming.responseStart")}} {{readonlyInline}}</dt>
 <dd>When the browser received the first byte of the response, from the server from a cache, or from a local resource.</dd>
 <dt>{{deprecated_inline}}  {{domxref("PerformanceTiming.responseEnd")}} {{readonlyInline}}</dt>
 <dd>When the browser received the last byte of the response, or when the connection is closed if this happened first, from the server, the cache, or from a local resource.</dd>
 <dt>{{deprecated_inline}}  {{domxref("PerformanceTiming.domLoading")}} {{readonlyInline}}</dt>
 <dd>When the parser started its work, that is when its {{domxref("Document.readyState")}} changes to <code>'loading'</code> and the corresponding {{event("readystatechange")}} event is thrown.</dd>
 <dt>{{deprecated_inline}}  {{domxref("PerformanceTiming.domInteractive")}} {{readonlyInline}}</dt>
 <dd>When the parser finished its work on the main document, that is when its {{domxref("Document.readyState")}} changes to <code>'interactive'</code> and the corresponding {{event("readystatechange")}} event is thrown.</dd>
 <dt>{{deprecated_inline}}  {{domxref("PerformanceTiming.domContentLoadedEventStart")}} {{readonlyInline}}</dt>
 <dd>Right before the parser sent the {{event("DOMContentLoaded")}} event, that is right after all the scripts that need to be executed right after parsing have been executed.</dd>
 <dt>{{deprecated_inline}}  {{domxref("PerformanceTiming.domContentLoadedEventEnd")}} {{readonlyInline}}</dt>
 <dd>Right after all the scripts that need to be executed as soon as possible, in order or not, have been executed.</dd>
 <dt>{{deprecated_inline}}  {{domxref("PerformanceTiming.domComplete")}} {{readonlyInline}}</dt>
 <dd>When the parser finished its work on the main document, that is when its {{domxref("Document.readyState")}} changes to <code>'complete'</code> and the corresponding {{event("readystatechange")}} event is thrown.</dd>
 <dt>{{deprecated_inline}}  {{domxref("PerformanceTiming.loadEventStart")}} {{readonlyInline}}</dt>
 <dd>When the {{event("load")}} event was sent for the current document. If this event has not yet been sent, it returns <code>0.</code></dd>
 <dt>{{deprecated_inline}}  {{domxref("PerformanceTiming.loadEventEnd")}} {{readonlyInline}}</dt>
 <dd>When the {{event("load")}} event handler terminated, that is when the load event is completed. If this event has not yet been sent, or is not yet completed, it returns <code>0.</code></dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>The <code>PerformanceTiming</code></em> <em>interface doesn't inherit any methods.</em></p>

<dl>
 <dt>{{deprecated_inline}}  {{domxref("PerformanceTiming.toJSON()")}} {{non-Standard_Inline}}</dt>
 <dd>Returns a <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/JSON">JSON object</a> representing this <code>PerformanceTiming</code> object.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Navigation Timing', '#performancetiming', 'PerformanceTiming')}}</td>
   <td>{{Spec2('Navigation Timing')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.PerformanceTiming")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>The {{domxref("Performance.timing")}} property that creates such an object.</li>
</ul>
